# include "xhfs.h"

char xhfs[] =
"set tk_strictMotif 1\n"
"set gNormalFont {-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1}\n"
"set gThinFont {-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1}\n"
"set gSmallFont {-adobe-helvetica-medium-r-normal-*-*-100-*-*-p-*-iso8859-1}\n"
"set gTypeFont {-*-lucidatypewriter-medium-r-normal-*-*-120-*-*-m-*-iso8859-1}\n"
"set gTitleFont {-*-lucida-bold-i-normal-*-*-250-*-*-p-*-iso8859-1}\n"
"set gDefaultDevice /dev/fd0\n"
"set gLowFormatCmd [list fdformat $gDefaultDevice]\n"
"set gMountSide .l\n"
"set gFlushInterval 30000\n"
"set gDfCmd [list df]\n"
"option add *Font $gNormalFont\n"
"if {[catch {exec uname} gUname] == 0} {\n"
"switch $gUname {\n"
"SunOS {\n"
"if {[catch {exec uname -r} gUrelease] == 0} {\n"
"switch -glob $gUrelease {\n"
"4.* {\n"
"set gLowFormatCmd [list fdformat -f /dev/rfd0]\n"
"}\n"
"5.* {\n"
"set gDefaultDevice /vol/dev/aliases/floppy0\n"
"set gLowFormatCmd [list fdformat -f $gDefaultDevice]\n"
"set gDfCmd [list df -k]\n"
"}\n"
"}\n"
"}\n"
"}\n"
"FreeBSD {\n"
"set gDefaultDevice /dev/rfd0\n"
"set gLowFormatCmd [list fdformat $gDefaultDevice]\n"
"}\n"
"}\n"
"}\n"
"set gUnique 0\n"
"proc unique {} {\n"
"global gUnique\n"
"return [incr gUnique]\n"
"}\n"
"proc window {title iconname} {\n"
"set w \".w[unique]\"\n"
"toplevel $w -cursor left_ptr -relief raised -bd 1\n"
"wm title $w $title\n"
"wm iconname $w $iconname\n"
"wm transient $w .\n"
"wm withdraw $w\n"
"return $w\n"
"}\n"
"proc showwindow {w} {\n"
"update idletasks\n"
"set x [expr [winfo x .] + [winfo width  .]/2 - [winfo reqwidth  $w]/2]\n"
"set y [expr [winfo y .] + [winfo height .]/3 - [winfo reqheight $w]/3]\n"
"wm geom $w +$x+$y\n"
"wm deiconify $w\n"
"}\n"
"proc dialog {title cancel {ok \"\"} {default 0}} {\n"
"set w \".d[unique]\"\n"
"toplevel $w -class Dialog -cursor left_ptr\n"
"wm title $w $title\n"
"wm transient $w .\n"
"wm withdraw $w\n"
"frame $w.top -relief raised -bd 1\n"
"frame $w.bot -relief raised -bd 1\n"
"pack $w.top -side top -expand 1 -fill both -ipadx 4m -ipady 4m\n"
"pack $w.bot -side bottom -fill both -ipadx 2m -ipady 2m\n"
"frame $w.bot.default -relief sunken -bd 1\n"
"button $w.bot.cancel -width 6 -text $cancel  \\\n"
"-command \"set gAnswer 0; [list destroy $w]\"\n"
"if {[string length $ok] > 0} {\n"
"button $w.bot.ok -width 6 -text $ok  \\\n"
"-command \"set gAnswer 1; [list destroy $w]\"\n"
"}\n"
"if {$default} {\n"
"pack $w.bot.cancel -side left -expand 1;# -ipadx 2m -ipady 1m\n"
"pack $w.bot.default -side left -expand 1 -ipadx 1m -ipady 1m\n"
"pack $w.bot.ok -in $w.bot.default -expand 1;# -ipadx 2m -ipady 1m\n"
"bind $w <Key-Return> [list $w.bot.ok invoke]\n"
"} else {\n"
"pack $w.bot.default -side left -expand 1 -ipadx 1m -ipady 1m\n"
"pack $w.bot.cancel -in $w.bot.default -expand 1;# -ipadx 2m -ipady 1m\n"
"if {[string length $ok] > 0} {\n"
"pack $w.bot.ok -side left -expand 1;# -ipadx 2m -ipady 1m\n"
"}\n"
"bind $w <Key-Return> [list $w.bot.cancel invoke]\n"
"}\n"
"return $w\n"
"}\n"
"proc showdialog {w} {\n"
"showwindow $w\n"
"grab set $w\n"
"}\n"
"proc alert {kind title text {aspect 100}} {\n"
"global gThinFont\n"
"set w [dialog $title \"OK\"]\n"
"frame $w.top.x\n"
"label $w.top.x.icon -bitmap $kind -anchor n\n"
"frame $w.top.x.space -width 2m\n"
"message $w.top.x.msg -aspect $aspect -font $gThinFont -text $text\n"
"pack $w.top.x.icon $w.top.x.space $w.top.x.msg -side left -fill y\n"
"pack $w.top.x -expand 1\n"
"showdialog $w\n"
"tkwait window $w\n"
"}\n"
"proc bgerror {error} {\n"
"alert stop \"Error\" \"Sorry, $error.\" 1000\n"
"return -code break\n"
"}\n"
"proc fixtext {text} {\n"
"regsub -all \"(\\[^\\n])\\n\\[ \\t]*(\\[^\\n])\" $text {\\1 \\2} text\n"
"regsub -all \"(^|\\n)\\[ \\t]+\" $text {\\1} text\n"
"regsub \"\\n*\\$\" $text \"\" text\n"
"return $text\n"
"}\n"
"proc copy_ufs_to_hfs {srcvol name mode dstvol} {\n"
"$dstvol copyin $mode \"[$srcvol cwd]/$name\" :\n"
"}\n"
"proc copy_hfs_to_ufs {srcvol name mode dstvol} {\n"
"$srcvol copyout $mode $name \"[$dstvol cwd]/.\"\n"
"}\n"
"proc copy_hfs_to_hfs {srcvol name mode dstvol} {\n"
"$srcvol copy $name $dstvol :\n"
"}\n"
"proc copy_ufs_to_ufs {srcvol name mode dstvol} {\n"
"$srcvol copy $name \"[$dstvol cwd]/.\"\n"
"}\n"
"proc copy_directory {srcvol name dstvol copyproc modeproc} {\n"
"global gXMode\n"
"set srccwd [abspath [$srcvol sepchar] [$srcvol path]]\n"
"set dstcwd [abspath [$dstvol sepchar] [$dstvol path]]\n"
"$dstvol mkdir $name\n"
"$srcvol chdir $name\n"
"$dstvol chdir $name\n"
"foreach ind [$srcvol dir] {\n"
"array set item $ind\n"
"if {$item(kind) == \"directory\"} {\n"
"copy_directory $srcvol $item(name) $dstvol $copyproc $modeproc\n"
"} else {\n"
"if {$gXMode == \"auto\"} {\n"
"set mode [$modeproc $srcvol item]\n"
"} else {\n"
"set mode $gXMode\n"
"}\n"
"$copyproc $srcvol $item(name) $mode $dstvol\n"
"}\n"
"}\n"
"$srcvol chdir $srccwd\n"
"$dstvol chdir $dstcwd\n"
"}\n"
"proc delete_directory {vol name} {\n"
"set cwd [abspath [$vol sepchar] [$vol path]]\n"
"$vol chdir $name\n"
"foreach ind [$vol dir] {\n"
"array set item $ind\n"
"if {$item(kind) == \"directory\"} {\n"
"delete_directory $vol $item(name)\n"
"} else {\n"
"$vol delete $item(name)\n"
"}\n"
"}\n"
"$vol chdir $cwd\n"
"$vol rmdir $name\n"
"}\n"
"proc do_open {side} {\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"set ind [lindex $sel 0]\n"
"global vol\n"
"set name [$box get $ind]\n"
"if {[regexp \"(.*)[$vol($side) sepchar]\\$\" $name ignore name]} {\n"
"mchdir $side $name\n"
"} else {\n"
"show_file $side $name\n"
"}\n"
"}\n"
"proc do_copy {side other} {\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"global gXMode gAskDelete gAnswer\n"
"global fstype dir vol\n"
"if {$side == \".l\"} {\n"
"set other \".r\"\n"
"} else {\n"
"set other \".l\"\n"
"}\n"
"set needupdate 0\n"
"foreach ind $sel {\n"
"array set item [lindex $dir($side) $ind]\n"
"$box see $ind\n"
"watch_cursor\n"
"if {$item(kind) == \"directory\"} {\n"
"set update [after idle  \\\n"
"\"[list updatelist $side]; [list updatelist $other]\"]\n"
"copy_directory $vol($side) $item(name) $vol($other)  \\\n"
"copy_$fstype($side)_to_$fstype($other)  \\\n"
"$fstype($side)_automode\n"
"} else {\n"
"set update [after idle [list updatelist $other]]\n"
"if {$gXMode == \"auto\"} {\n"
"set mode [$fstype($side)_automode $vol($side) item]\n"
"} else {\n"
"set mode $gXMode\n"
"}\n"
"copy_$fstype($side)_to_$fstype($other)  \\\n"
"$vol($side) $item(name) $mode $vol($other)\n"
"}\n"
"after cancel $update\n"
"set needupdate 1\n"
"$box selection clear $ind\n"
"}\n"
"if {$needupdate} {\n"
"updatelist $other; clearlists\n"
"}\n"
"}\n"
"proc do_info {side} {\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"global vol dir\n"
"foreach ind $sel {\n"
"show_info $vol($side) [lindex $dir($side) $ind]\n"
"}\n"
"}\n"
"proc do_rename {side} {\n"
"global dir\n"
"global gTypeFont\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"array set item [lindex $dir($side) [lindex $sel 0]]\n"
"set w [dialog \"Rename\" \"Cancel\" \"Rename\" 1]\n"
"$w.bot.ok config -command [list rename2 $w $side]\n"
"frame $w.top.x\n"
"label $w.top.x.lbl -text \"Rename \\\"$item(name)\\\" to:\"\n"
"label $w.top.x.srcname -text $item(name)\n"
"entry $w.top.x.dstname -width 25 -font $gTypeFont -exportsel 0\n"
"pack $w.top.x.lbl $w.top.x.dstname -side top -pady 0.5m\n"
"pack $w.top.x -expand 1\n"
"$w.top.x.dstname insert end $item(name)\n"
"$w.top.x.dstname selection range 0 end\n"
"focus $w.top.x.dstname\n"
"showdialog $w\n"
"}\n"
"proc rename2 {w side} {\n"
"global vol\n"
"set srcname [$w.top.x.srcname cget -text]\n"
"set dstname [$w.top.x.dstname get]\n"
"watch_cursor $w\n"
"destroy $w\n"
"if {[string length $dstname] == 0} {\n"
"error \"cannot rename to zero-length name\"\n"
"}\n"
"if {[string compare $srcname $dstname] != 0} {\n"
"$vol($side) rename $srcname $dstname\n"
"updatelist $side; clearlists\n"
"}\n"
"}\n"
"proc do_delete {side} {\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"global gThinFont gAskDelete gAnswer\n"
"global vol dir\n"
"set sepchar [$vol($side) sepchar]\n"
"set needupdate 0\n"
"foreach ind $sel {\n"
"array set item [lindex $dir($side) $ind]\n"
"$box see $ind\n"
"set recursive [expr {$item(kind) == \"directory\" && $item(size) > 0}]\n"
"if {$recursive || $gAskDelete} {\n"
"set w [dialog \"Delete\" \"Cancel\" \"Delete\"]\n"
"if {$recursive} {\n"
"set p1 \"Recursively delete \\\"$item(name)\\\"\"\n"
"set p2 \"containing $item(size) item[plural $item(size) \"\" \"s\"]\"\n"
"set prompt \"$p1 $p2?\"\n"
"} else {\n"
"set prompt \"Really delete \\\"$item(name)\\\"?\"\n"
"}\n"
"frame $w.top.x\n"
"label $w.top.x.icon -bitmap caution -anchor n\n"
"frame $w.top.x.space -width 2m\n"
"message $w.top.x.msg -font $gThinFont -aspect 500 -text $prompt\n"
"pack $w.top.x.icon $w.top.x.space $w.top.x.msg -side left -fill y\n"
"pack $w.top.x -expand 1\n"
"showdialog $w\n"
"tkwait window $w\n"
"if {$gAnswer == 0} {\n"
"break\n"
"}\n"
"}\n"
"watch_cursor\n"
"set update [after idle \"[list updatelist $side]; clearlists\"]\n"
"if {$item(kind) == \"directory\"} {\n"
"delete_directory $vol($side) $item(name)\n"
"} else {\n"
"$vol($side) delete $item(name)\n"
"}\n"
"after cancel $update\n"
"set needupdate 1\n"
"$box selection clear $ind\n"
"}\n"
"if {$needupdate} {\n"
"updatelist $side; clearlists\n"
"}\n"
"}\n"
"proc format_disk {} {\n"
"global gTypeFont gThinFont gLowFormatCmd gDefaultDevice\n"
"set w [dialog \"Format Disk\" \"Cancel\" \"Format\"]\n"
"$w.bot.ok config -command [list format2 $w]\n"
"frame $w.top.x\n"
"set low [frame $w.top.x.low]\n"
"label $low.icon -bitmap floppy\n"
"frame $low.info\n"
"checkbutton $low.info.cb -var gLowFormat  \\\n"
"-text \"Low-level Format\" -anchor w\n"
"entry $low.info.cmd -width 26 -font $gTypeFont\n"
"pack $low.info.cb $low.info.cmd -side top -fill x -pady 0.5m\n"
"pack $low.icon $low.info -side left -padx 2m\n"
"frame $w.top.x.space1 -height 2m\n"
"label $w.top.x.hfs -text \"Initialize as HFS Volume...\" -anchor w\n"
"set dev [frame $w.top.x.dev]\n"
"label $dev.lbl -width 6 -text \"Device:\" -font $gThinFont -anchor w\n"
"entry $dev.name -width 15 -font $gTypeFont\n"
"label $dev.parlbl -text \"Partition:\" -font $gThinFont\n"
"entry $dev.par -width 2 -font $gTypeFont\n"
"pack $dev.lbl $dev.name $dev.parlbl $dev.par -side left -padx 0.5m\n"
"set vol [frame $w.top.x.vol]\n"
"label $vol.lbl -width 6 -text \"Name:\" -font $gThinFont -anchor w\n"
"entry $vol.name -width 27 -font $gTypeFont\n"
"pack $vol.lbl $vol.name -side left -padx 0.5m\n"
"frame $w.top.x.space2 -height 2m\n"
"set mount [frame $w.top.x.mount]\n"
"label $mount.lbl -text \"Open:\" -font $gThinFont\n"
"radiobutton $mount.l -var gMountSide -value \".l\"  \\\n"
"-text \"On Left\" -font $gThinFont\n"
"radiobutton $mount.r -var gMountSide -value \".r\"  \\\n"
"-text \"On Right\" -font $gThinFont\n"
"pack $mount.lbl $mount.l $mount.r -side left\n"
"pack $low $w.top.x.space1 $w.top.x.hfs $dev $vol  \\\n"
"-side top -fill x -pady 0.5m\n"
"pack $w.top.x.space2 $mount -side top -pady 0.5m\n"
"pack $w.top.x -expand 1\n"
"$w.top.x.low.info.cmd insert end $gLowFormatCmd\n"
"$w.top.x.dev.name insert end $gDefaultDevice\n"
"$w.top.x.vol.name insert end \"Untitled\"\n"
"showdialog $w\n"
"}\n"
"proc format2 {w} {\n"
"global gAppCWD gLowFormat gLowFormatCmd gMountSide\n"
"set gLowFormatCmd [$w.top.x.low.info.cmd get]\n"
"set path [$w.top.x.dev.name get]\n"
"set partno [$w.top.x.dev.par get]\n"
"set vname [$w.top.x.vol.name get]\n"
"if {[string length $partno] == 0} {\n"
"set partno 0\n"
"}\n"
"watch_cursor $w\n"
"destroy $w\n"
"cd $gAppCWD\n"
"if {$gLowFormat && [string length $gLowFormatCmd] > 0} {\n"
"exec /bin/sh -c $gLowFormatCmd </dev/null >/dev/null\n"
"}\n"
"if {[string length $path] > 0} {\n"
"hfs format $path $partno $vname\n"
"mountdev $gMountSide $path\n"
"}\n"
"}\n"
"proc help_about {} {\n"
"global gThinFont gSmallFont gTitleFont\n"
"set w [dialog \"About\" \"OK\"]\n"
"set f [frame $w.top.t]\n"
"regsub {\\(C\\)} [hfs copyright] \"\\251\" copyright\n"
"frame $f.banner\n"
"label $f.banner.icon -bitmap macdaemon\n"
"label $f.banner.title -text \"xhfs\" -font $gTitleFont\n"
"pack $f.banner.icon $f.banner.title -side left -padx 2m\n"
"frame $f.space -height 2m\n"
"label $f.vers -text [hfs version] -font $gThinFont\n"
"label $f.copy -text $copyright -font $gSmallFont\n"
"label $f.auth -text [hfs author] -font $gSmallFont\n"
"pack $f.banner $f.space $f.vers $f.copy $f.auth -side top\n"
"pack $f -expand 1\n"
"showdialog $w\n"
"}\n"
"proc help_license {} {\n"
"alert note \"Software License\" [fixtext [hfs license]] 190\n"
"}\n"
"proc help_options {} {\n"
"set text \"\\\n"
"Show All Files: Some files are normally hidden. To unhide\\n\\\n"
"invisible files on HFS volumes, or to unhide UNIX files which\\n\\\n"
"begin with a period, select this option.\\n\\n\\\n"
"\\\n"
"Ask Before Delete: To disable verification before deleting files\\n\\\n"
"and empty directories, deselect this option.\\n\\n\\\n"
"\\\n"
"Auto Mode Select: The transfer mode is normally selected\\n\\\n"
"automatically. To use manual selection, deselect this option.\\n\\n\\\n"
"\"\n"
"alert note \"Options\" [fixtext $text] 150\n"
"}\n"
"proc help_modes {} {\n"
"set text \"\\\n"
"MacBinary II: A popular format for binary file transfer. Both\\n\\\n"
"forks of the Macintosh file are preserved. This is the\\n\\\n"
"recommended mode for transferring arbitrary Macintosh files.\\n\\n\\\n"
"\\\n"
"BinHex: An alternative format for ASCII file transfer. Both\\n\\\n"
"forks of the Macintosh file are preserved.\\n\\n\\\n"
"\\\n"
"Text: Performs end-of-line translation. Only the data fork of\\n\\\n"
"the Macintosh file is copied.\\n\\n\\\n"
"\\\n"
"Raw Data: Performs no translation. Only the data fork of the\\n\\\n"
"Macintosh file is copied.\\n\\n\\\n"
"\\\n"
"Automatic: A mode will be chosen automatically for each\\n\\\n"
"file based on a set of predefined heuristics.\\n\\n\\\n"
"\"\n"
"alert note \"Transfer Modes\" [fixtext $text]\n"
"}\n"
"proc hfs_automode {vol array} {\n"
"upvar $array item\n"
"if {$item(kind) == \"directory\"} {\n"
"return auto\n"
"} elseif {[regexp {^TEXT|ttro$} $item(type)]} {\n"
"return text\n"
"} elseif {$item(rsize) == 0} {\n"
"return raw\n"
"} else {\n"
"return macb\n"
"}\n"
"}\n"
"proc ufs_automode {vol array} {\n"
"upvar $array item\n"
"set name $item(name)\n"
"if {$item(kind) == \"directory\"} {\n"
"return auto\n"
"} elseif {[regexp -nocase {\\.bin$} $name]} {\n"
"return macb\n"
"} elseif {[regexp -nocase {\\.hqx$} $name]} {\n"
"return binh\n"
"} elseif {[regexp -nocase {\\.(txt|c|h|html?|rtf)$} $name]} {\n"
"return text\n"
"} elseif {[regexp -nocase {\\.(sit|sea|cpt|tar|gz|Z|gif|jpg)$} $name]} {\n"
"return raw\n"
"} else {\n"
"cd [$vol cwd]\n"
"if {([catch {exec file -L $name} type] == 0 ||  \\\n"
"[catch {exec file $name} type] == 0) &&  \\\n"
"[regexp {text|commands} $type]} {\n"
"return text\n"
"}\n"
"return raw\n"
"}\n"
"} \n"
"proc watch_cursor {{w \".\"} {default \"left_ptr\"}} {\n"
"$w config -cursor watch\n"
"if {[string compare $w \".\"] != 0} {\n"
". config -cursor watch\n"
"}\n"
"update idletasks\n"
"$w config -cursor $default\n"
"if {[string compare $w \".\"] != 0} {\n"
". config -cursor left_ptr\n"
"}\n"
"}\n"
"proc updatelist {side} {\n"
"global gShowAllFiles\n"
"global dir vol fstype\n"
"set box $side.mid.lb\n"
"$box delete 0 end\n"
"if {! [info exists vol($side)]} {\n"
"return\n"
"}\n"
"if {$fstype($side) == \"hfs\"} {\n"
"set chartrans {nulltrans} ;# {hfs charlocal}\n"
"} else {\n"
"set chartrans {nulltrans}\n"
"}\n"
"set list [$vol($side) dir]\n"
"set dir($side) {}\n"
"set sepchar [$vol($side) sepchar]\n"
"foreach ent $list {\n"
"array set item $ent\n"
"set name [eval $chartrans [list $item(name)]]\n"
"if {$item(kind) == \"directory\"} {\n"
"set name \"$name$sepchar\"\n"
"}\n"
"if {$gShowAllFiles || [lsearch $item(flags) \"invis\"] < 0} {\n"
"$box insert end $name\n"
"lappend dir($side) $ent\n"
"}\n"
"}\n"
"set m $side.mb.pop.m\n"
"$m delete 0 end\n"
"set path [$vol($side) path]\n"
"set last 0\n"
"foreach elt $path {\n"
"set partial [abspath [$vol($side) sepchar] [lrange $path 0 $last]]\n"
"incr last\n"
"$m insert 0 command -label $elt -command [list mchdir $side $partial]\n"
"}\n"
"if {$fstype($side) == \"hfs\"} {\n"
"set what \"Folder\"\n"
"} else {\n"
"set what \"Directory\"\n"
"}\n"
"foreach menuitem {\n"
"{separator}\n"
"{command -label \"New $what...\" -command [list mmkdir $side]}\n"
"} {eval $m insert end $menuitem}\n"
"global cwd\n"
"set cwd($side) [lindex $path [expr [llength $path] - 1]]\n"
"set avail [lindex [$vol($side) size] 1]\n"
"$side.info.x.msg config -text \"[size $avail] available\"\n"
"}\n"
"proc clearlists {} {\n"
".l.mid.lb selection clear 0 end\n"
".r.mid.lb selection clear 0 end\n"
".m.1.ops.view config -state disabled -text \"View\"\n"
".m.1.ops.copy config -state disabled -text \"Copy\"\n"
".m.2.ops.info config -state disabled\n"
".m.2.ops.rena config -state disabled\n"
".m.2.ops.dele config -state disabled\n"
"}\n"
"proc mchdir {side path} {\n"
"global vol\n"
"watch_cursor\n"
"$vol($side) chdir $path\n"
"updatelist $side; clearlists\n"
"}\n"
"proc open_volume {side} {\n"
"global gDefaultDevice gMountSide gTypeFont gThinFont\n"
"set gMountSide $side\n"
"set w [dialog \"Open\" \"Cancel\" \"Open\" 1]\n"
"$w.bot.ok config -command [list open2 $w]\n"
"frame $w.top.x\n"
"set lbl1 [frame $w.top.x.lbl1]\n"
"label $lbl1.path -text \"Path to HFS Device\"\n"
"pack $lbl1.path\n"
"set lbl2 [frame $w.top.x.lbl2]\n"
"label $lbl2.dev -text \"or UNIX Directory:\"\n"
"pack $lbl2.dev -side left -padx 0.5m\n"
"entry $w.top.x.entry -width 25 -font $gTypeFont\n"
"frame $w.top.x.space -height 2m\n"
"set mount [frame $w.top.x.mount]\n"
"label $mount.lbl -text \"Open:\" -font $gThinFont\n"
"radiobutton $mount.l -var gMountSide -value \".l\"  \\\n"
"-text \"On Left\" -font $gThinFont\n"
"radiobutton $mount.r -var gMountSide -value \".r\"  \\\n"
"-text \"On Right\" -font $gThinFont\n"
"pack $mount.lbl $mount.l $mount.r -side left\n"
"pack $lbl1 $lbl2 $w.top.x.entry $w.top.x.space $mount  \\\n"
"-side top -pady 0.5m\n"
"pack $w.top.x -expand 1\n"
"$w.top.x.entry insert end $gDefaultDevice\n"
"$w.top.x.entry selection range 0 end\n"
"focus $w.top.x.entry\n"
"showdialog $w\n"
"}\n"
"proc open2 {w} {\n"
"global gMountSide\n"
"global vol\n"
"set path [$w.top.x.entry get]\n"
"watch_cursor $w\n"
"destroy $w\n"
"if {[string length $path] == 0} {\n"
"error \"missing path\"\n"
"}\n"
"mountdev $gMountSide $path\n"
"}\n"
"proc close_volume {side} {\n"
"global vol\n"
"watch_cursor\n"
"$vol($side) umount\n"
"unset vol($side)\n"
"pack forget $side.mb.pop $side.info.x.icon $side.info.x.lock\n"
"$side.info.x.msg config -text \"\"\n"
"$side.sub.open config -text \"Open...\" -command [list open_volume $side]\n"
"$side.sub.info config -state disabled\n"
"updatelist $side; clearlists\n"
"}\n"
"proc ctime {secs} {\n"
"return [clock format $secs -format \"%c\"]\n"
"}\n"
"proc volume_info {side} {\n"
"global gThinFont\n"
"global vol dev fstype media\n"
"set v $vol($side)\n"
"if {$side == \".l\"} {\n"
"set eside \"Left\"\n"
"} else {\n"
"set eside \"Right\"\n"
"}\n"
"set w [window \"$eside Info\" \"Info\"]\n"
"set locked [$v islocked]\n"
"set icon $media($side)\n"
"set vname [$v vname]\n"
"if {$fstype($side) == \"ufs\"} {\n"
"set ishfs 0\n"
"set where [file dirname $vname]\n"
"set vname [file tail $vname]\n"
"set kind \"UNIX Directory\"\n"
"} else {\n"
"set ishfs 1\n"
"set kind \"HFS Volume\"\n"
"set where $dev($side)\n"
"set crdate [$v crdate]\n"
"}\n"
"wm iconbitmap $w $icon\n"
"wm iconmask $w ${icon}_mask\n"
"frame $w.x\n"
"pack $w.x -expand 1 -fill both -ipadx 4m -ipady 4m\n"
"set f [frame $w.x.f]\n"
"frame $f.name\n"
"frame $f.name.space -width 5\n"
"label $f.name.icon -bitmap $icon\n"
"label $f.name.text -text $vname -font $gThinFont\n"
"pack $f.name.space $f.name.icon $f.name.text -side left -padx 2m\n"
"if {$locked} {\n"
"label $f.name.lock -bitmap padlock\n"
"pack $f.name.lock -side left\n"
"}\n"
"frame $f.space1 -height 4m\n"
"frame $f.kind\n"
"label $f.kind.lbl -width 9 -text \"Kind: \" -anchor e\n"
"label $f.kind.val -text $kind -font $gThinFont\n"
"pack $f.kind.lbl $f.kind.val -side left\n"
"frame $f.size\n"
"label $f.size.lbl -width 9 -text \"Size: \" -anchor e\n"
"label $f.size.val -text [size [lindex [$v size] 0]] -font $gThinFont\n"
"pack $f.size.lbl $f.size.val -side left\n"
"frame $f.space2 -height 4m\n"
"frame $f.where\n"
"label $f.where.lbl -width 9 -text \"Where: \" -anchor e\n"
"label $f.where.val -text $where -font $gThinFont\n"
"pack $f.where.lbl $f.where.val -side left\n"
"pack $f.name $f.space1 $f.kind $f.size $f.space2 $f.where -side top -fill x\n"
"if {$ishfs} {\n"
"frame $f.space3 -height 4m\n"
"frame $f.cr\n"
"label $f.cr.lbl -width 9 -text \"Created: \" -anchor e\n"
"label $f.cr.val -text [ctime $crdate] -font $gThinFont\n"
"pack $f.cr.lbl $f.cr.val -side left\n"
"pack $f.space3 $f.cr -side top -fill x\n"
"}\n"
"frame $f.md\n"
"label $f.md.lbl -width 9 -text \"Modified: \" -anchor e\n"
"label $f.md.val -text [ctime [$v mddate]] -font $gThinFont\n"
"pack $f.md.lbl $f.md.val -side left\n"
"pack $f.md -side top -fill x\n"
"pack $f -expand 1\n"
"showwindow $w\n"
"}\n"
"proc mmkdir {side} {\n"
"global gTypeFont\n"
"global fstype\n"
"if {$fstype($side) == \"hfs\"} {\n"
"set what \"folder\"\n"
"set title \"New Folder\"\n"
"} else {\n"
"set what \"directory\"\n"
"set title \"New Directory\"\n"
"}\n"
"set w [dialog $title \"Cancel\" \"Create\" 1]\n"
"$w.bot.ok config -command [list mmkdir2 $w $side $what]\n"
"frame $w.top.x\n"
"frame $w.top.x.lbl\n"
"label $w.top.x.lbl.icon -bitmap sm_folder\n"
"label $w.top.x.lbl.text -text \"Name for new $what:\"\n"
"pack $w.top.x.lbl.icon $w.top.x.lbl.text -side left -padx 0.5m\n"
"entry $w.top.x.entry -width 25 -font $gTypeFont -exportsel 0\n"
"pack $w.top.x.lbl $w.top.x.entry -side top -pady 0.5m\n"
"pack $w.top.x -expand 1\n"
"$w.top.x.entry insert end \"untitled $what\"\n"
"$w.top.x.entry selection range 0 end\n"
"focus $w.top.x.entry\n"
"showdialog $w\n"
"}\n"
"proc mmkdir2 {w side what} {\n"
"global vol\n"
"set name [$w.top.x.entry get]\n"
"watch_cursor $w\n"
"destroy $w\n"
"if {[string length $name] == 0} {\n"
"error \"cannot create $what with empty name\"\n"
"}\n"
"$vol($side) mkdir $name\n"
"$vol($side) chdir $name\n"
"updatelist $side; clearlists\n"
"}\n"
"proc plural {count single plural} {\n"
"if {$count == 1} {\n"
"return $single\n"
"} else {\n"
"return $plural\n"
"}\n"
"}\n"
"proc nulltrans {str} {\n"
"return $str\n"
"}\n"
"proc show_file {side fname} {\n"
"global gTypeFont\n"
"global vol fstype\n"
"watch_cursor\n"
"if {$fstype($side) == \"hfs\"} {\n"
"set charset macroman\n"
"} else {\n"
"set charset latin1\n"
"}\n"
"set fh [$vol($side) open $fname]\n"
"set path [abspath [$vol($side) sepchar]  \\\n"
"[concat [$vol($side) path] [list $fname]] 1]\n"
"set w [window $path $fname]\n"
"frame $w.x\n"
"pack $w.x -expand 1 -fill both -padx 1m -pady 1m\n"
"set f [frame $w.x.f]\n"
"text $f.text -yscroll [list $f.scroll set]  \\\n"
"-height 30 -width 80 -wrap word -font $gTypeFont\n"
"scrollbar $f.scroll -orient vert -command [list $f.text yview]\n"
"pack $f.scroll -side right -fill y\n"
"pack $f.text -fill both -expand 1\n"
"pack $f -fill both -expand 1\n"
"watch_cursor $f.text xterm\n"
"after idle \"[list $f.text config -state disabled]; [list showwindow $w]\"\n"
"while {1} {\n"
"set buf [$fh read 512]\n"
"if {[string length $buf] == 0} {\n"
"$fh close\n"
"break\n"
"}\n"
"regsub -all \"\\r\\n?\" $buf \"\\n\" buf\n"
"$f.text insert end [hfs chartrans $charset latin1 $buf]\n"
"}\n"
"}\n"
"proc commas {number} {\n"
"while {[regexp  \\\n"
"{([^,]+)(([0-9][0-9][0-9])(,[0-9][0-9][0-9])*([^0-9].*|$))}  \\\n"
"$number ignore pre rest]} {\n"
"set number \"$pre,$rest\"\n"
"}\n"
"return $number\n"
"}\n"
"proc size {bytes} {\n"
"if {$bytes == -1} {\n"
"return \"unknown K\"\n"
"}\n"
"set k 1024\n"
"set mb [expr 1024 * $k]\n"
"if {$bytes > $mb} {\n"
"set q $mb\n"
"set u \"M\"\n"
"} else {\n"
"set q $k\n"
"set u \"K\"\n"
"}\n"
"set amount [commas [format \"%.1f\" [expr ${bytes}.0 / $q]]]\n"
"regsub {\\.0$} $amount \"\" amount\n"
"regsub {^0$} $amount \"zero \" amount\n"
"return \"$amount$u\"\n"
"}\n"
"proc show_info {vol list} {\n"
"global gTypeFont gThinFont\n"
"array set info $list\n"
"set isdir [expr [string compare $info(kind) \"directory\"] == 0]\n"
"set ishfs [info exists info(crdate)]\n"
"if {$ishfs} {\n"
"set chartrans {nulltrans} ;# {hfs charlocal}\n"
"} else {\n"
"set chartrans {nulltrans}\n"
"}\n"
"set name [eval $chartrans [list $info(name)]]\n"
"set w [window \"$name Info\" $name]\n"
"set icon \"document\"\n"
"if {$isdir} {\n"
"set icon \"folder\"\n"
"if {$ishfs} {\n"
"set info(kind) \"folder\"\n"
"}\n"
"} else {\n"
"if {$ishfs} {\n"
"if {[string compare $info(type) \"APPL\"] == 0} {\n"
"set icon \"application\"\n"
"set info(kind) \"application\"\n"
"} else {\n"
"set info(kind) \"document\"\n"
"}\n"
"} else {\n"
"cd [$vol cwd]\n"
"if {[file executable $info(name)]} {\n"
"set icon \"application\"\n"
"}\n"
"}\n"
"}\n"
"wm iconbitmap $w $icon\n"
"wm iconmask $w ${icon}_mask\n"
"if {$ishfs} {\n"
"set where \"[join [$vol path] \":\"]:\"\n"
"} else {\n"
"set where [$vol cwd]\n"
"cd $where\n"
"if {[catch {exec file $info(name)} type] == 0} {\n"
"if {[string first \"$info(name):\" $type] == 0} {\n"
"set type [string range $type  \\\n"
"[expr [string length $info(name)] + 1] end]\n"
"}\n"
"regsub \"^\\[ \\t]*\" $type \"\" info(kind)\n"
"}\n"
"}\n"
"frame $w.x\n"
"pack $w.x -expand 1 -fill both -ipadx 4m -ipady 4m\n"
"set f [frame $w.x.f]\n"
"frame $f.name\n"
"frame $f.name.space -width 5\n"
"label $f.name.icon -bitmap $icon\n"
"label $f.name.text -text $name -font $gThinFont\n"
"pack $f.name.space $f.name.icon $f.name.text -side left -padx 2m\n"
"if {[lsearch $info(flags) \"locked\"] >= 0} {\n"
"label $f.name.lock -bitmap padlock\n"
"pack $f.name.lock -side left\n"
"}\n"
"frame $f.space1 -height 4m\n"
"frame $f.kind\n"
"label $f.kind.lbl -width 9 -text \"Kind: \" -anchor e\n"
"label $f.kind.val -text $info(kind) -font $gThinFont\n"
"pack $f.kind.lbl $f.kind.val -side left\n"
"set label \"Size: \"\n"
"if {$isdir} {\n"
"set label \"Contains: \"\n"
"set size $info(size)\n"
"set what [plural $size item items]\n"
"} elseif {$ishfs} {\n"
"set size [list $info(rsize) $info(dsize)]\n"
"set what [list  \\\n"
"[plural $info(rsize) byte bytes]  \\\n"
"[plural $info(dsize) byte bytes]]\n"
"} else {\n"
"set size $info(size)\n"
"set what [plural $size byte bytes]\n"
"}\n"
"frame $f.size\n"
"if {[llength $size] == 1} {\n"
"label $f.size.lbl -width 9 -text $label -anchor e\n"
"label $f.size.val -text \"[commas $size] $what\" -font $gThinFont\n"
"pack $f.size.lbl $f.size.val -side left\n"
"} else {\n"
"set rsize [lindex $size 0]\n"
"set rwhat [lindex $what 0]\n"
"set dsize [lindex $size 1]\n"
"set dwhat [lindex $what 1]\n"
"frame $f.size.r\n"
"label $f.size.r.lbl -width 9 -text \"Resource: \" -anchor e\n"
"label $f.size.r.val -text \"[commas $rsize] $rwhat\" -font $gThinFont\n"
"pack $f.size.r.lbl $f.size.r.val -side left\n"
"frame $f.size.d\n"
"label $f.size.d.lbl -width 9 -text \"Data: \" -anchor e\n"
"label $f.size.d.val -text \"[commas $dsize] $dwhat\" -font $gThinFont\n"
"pack $f.size.d.lbl $f.size.d.val -side left\n"
"pack $f.size.r $f.size.d -side top -fill x\n"
"}\n"
"frame $f.space2 -height 4m\n"
"frame $f.where\n"
"label $f.where.lbl -width 9 -text \"Where: \" -anchor e\n"
"label $f.where.val -text $where -font $gThinFont\n"
"pack $f.where.lbl $f.where.val -side left\n"
"pack $f.name $f.space1 $f.kind $f.size $f.space2 $f.where -side top -fill x\n"
"if {$ishfs && ! $isdir} {\n"
"frame $f.space3 -height 4m\n"
"frame $f.type\n"
"label $f.type.lbl -width 9 -text \"Type: \" -anchor e\n"
"label $f.type.val -text $info(type) -font $gTypeFont\n"
"pack $f.type.lbl $f.type.val -side left\n"
"frame $f.crea\n"
"label $f.crea.lbl -width 9 -text \"Creator: \" -anchor e\n"
"label $f.crea.val -text $info(creator) -font $gTypeFont\n"
"pack $f.crea.lbl $f.crea.val -side left\n"
"pack $f.space3 $f.type $f.crea -side top -fill x\n"
"}\n"
"if {$ishfs} {\n"
"frame $f.space4 -height 4m\n"
"frame $f.cr\n"
"label $f.cr.lbl -width 9 -text \"Created: \" -anchor e\n"
"label $f.cr.val -text [ctime $info(crdate)] -font $gThinFont\n"
"pack $f.cr.lbl $f.cr.val -side left\n"
"pack $f.space4 $f.cr -side top -fill x\n"
"}\n"
"frame $f.md\n"
"label $f.md.lbl -width 9 -text \"Modified: \" -anchor e\n"
"label $f.md.val -text [ctime $info(mddate)] -font $gThinFont\n"
"pack $f.md.lbl $f.md.val -side left\n"
"pack $f.md -side top -fill x\n"
"pack $f -expand 1\n"
"showwindow $w\n"
"}\n"
"proc abspath {sepchar path {asfile 0}} {\n"
"switch $sepchar {\n"
"\":\" {\n"
"if {$asfile} {\n"
"return [join $path \":\"]\n"
"} else {\n"
"return \"[join $path \":\"]:\"\n"
"}\n"
"}\n"
"\"/\" {\n"
"if {[string compare [lindex $path 0] \"/\"] == 0} {\n"
"set path [lreplace $path 0 0 \"\"]\n"
"}\n"
"if {[llength $path] == 1 &&  \\\n"
"[string length [lindex $path 0]] == 0} {\n"
"return \"/\"\n"
"} else {\n"
"return [join $path \"/\"]\n"
"}\n"
"}\n"
"}\n"
"}\n"
"proc ufs_handle {dir} {\n"
"set handle \"ufsvol[unique]\"\n"
"global ufsdir\n"
"cd $dir\n"
"set ufsdir($handle) [pwd]\n"
"proc $handle {verb args} {\n"
"set handle [lindex [info level [info level]] 0]\n"
"global gAppCWD gDfCmd\n"
"global ufsdir\n"
"set cwd $ufsdir($handle)\n"
"switch -glob $verb {\n"
"vname {\n"
"return $cwd\n"
"}\n"
"umount {\n"
"cd $gAppCWD\n"
"unset ufsdir($handle)\n"
"rename $handle \"\"\n"
"}\n"
"path {\n"
"set path [split $cwd \"/\"]\n"
"if {[string compare [lindex $path 0] \"\"] == 0} {\n"
"set path [lreplace $path 0 0 \"/\"]\n"
"}\n"
"if {[llength $path] == 2 &&  \\\n"
"[string length [lindex $path 1]] == 0} {\n"
"set path [lreplace $path 1 1]\n"
"}\n"
"return $path\n"
"}\n"
"dir {\n"
"cd $cwd\n"
"set list {}\n"
"set files [lsort [glob .* *]]\n"
"foreach name $files {\n"
"if {[string compare $name \".\"] == 0 ||  \\\n"
"[string compare $name \"..\"] == 0} {\n"
"continue\n"
"}\n"
"if {[catch {file stat $name stat}]} {\n"
"continue\n"
"}\n"
"set kind [file type $name]\n"
"set mddate $stat(mtime)\n"
"if {[file isdirectory $name]} {\n"
"set kind \"directory\"\n"
"set size \"?\"\n"
"catch {\n"
"set size [expr [llength  \\\n"
"[glob $name/.* $name/*]] - 2]\n"
"}\n"
"} elseif {$kind == \"file\"} {\n"
"set size $stat(size)\n"
"} else {\n"
"continue\n"
"}\n"
"set flags {}\n"
"if {! [file writable $name]} {\n"
"lappend flags \"locked\"\n"
"}\n"
"if {[regexp {^\\.} $name]} {\n"
"lappend flags \"invis\"\n"
"}\n"
"lappend list [list  \\\n"
"name $name  \\\n"
"kind $kind  \\\n"
"size $size  \\\n"
"flags $flags  \\\n"
"mddate $mddate]\n"
"}\n"
"return $list\n"
"}\n"
"chdir {\n"
"set path [lindex $args 0]\n"
"if {! [regexp {^/} $path]} {\n"
"cd $cwd\n"
"}\n"
"cd $path\n"
"set ufsdir($handle) [pwd]\n"
"}\n"
"cwd {\n"
"return $cwd\n"
"}\n"
"sepchar {\n"
"return \"/\"\n"
"}\n"
"mkdir {\n"
"set path [lindex $args 0]\n"
"cd $cwd\n"
"exec mkdir $path\n"
"}\n"
"rmdir {\n"
"set path [lindex $args 0]\n"
"cd $cwd\n"
"exec rmdir $path\n"
"}\n"
"open {\n"
"set path [lindex $args 0]\n"
"cd $cwd\n"
"set fh [open $path]\n"
"proc $fh {verb args} {\n"
"set fh [lindex [info level [info level]] 0]\n"
"switch -glob $verb {\n"
"read {\n"
"set len [lindex $args 0]\n"
"return [read $fh $len]\n"
"}\n"
"close {\n"
"close $fh\n"
"rename $fh \"\"\n"
"}\n"
"* {\n"
"error \"unknown call to $fh $verb $args\"\n"
"}\n"
"}\n"
"}\n"
"return $fh\n"
"}\n"
"copy {\n"
"set path [lindex $args 0]\n"
"set dest [lindex $args 1]\n"
"cd $cwd\n"
"exec cp -f $path $dest\n"
"}\n"
"rename {\n"
"set path [lindex $args 0]\n"
"set dest [lindex $args 1]\n"
"cd $cwd\n"
"exec mv -f $path $dest\n"
"}\n"
"delete {\n"
"set path [lindex $args 0]\n"
"cd $cwd\n"
"exec rm -f $path\n"
"}\n"
"size {\n"
"if {[catch {eval exec [join $gDfCmd \" \"] [list $cwd]} info]} {\n"
"return [list -1 -1]\n"
"}\n"
"set s \"\\[ \\t]+\"\n"
"set d \"\\[0-9]+\"\n"
"if {[catch {\n"
"regexp \"(.*)\\n(\\[^\\n]*)\\$\" $info ignore head data\n"
"regexp \"${s}($d)$s$d${s}($d)\" $data ignore size avail\n"
"}]} {\n"
"return [list -1 -1]\n"
"}\n"
"set block 512\n"
"if {[regexp -nocase {kbyte|1024} $head]} {\n"
"set block 1024\n"
"}\n"
"return [list [expr $size * $block] [expr $avail * $block]]\n"
"}\n"
"mddate {\n"
"return [file mtime $cwd]\n"
"}\n"
"islocked {\n"
"return 0\n"
"}\n"
"* {\n"
"error \"unknown call to $handle $verb $args\"\n"
"}\n"
"}\n"
"}\n"
"return $handle\n"
"}\n"
"proc ufs {verb args} {\n"
"switch $verb {\n"
"mount {\n"
"set dir [lindex $args 0]\n"
"return [ufs_handle $dir]\n"
"}\n"
"* {\n"
"error \"bad arg 1 to ufs\"\n"
"}\n"
"}\n"
"}\n"
"proc mountdev {side device} {\n"
"global gAppCWD gXMode\n"
"global vol dev fstype media\n"
"if {[info exists vol($side)]} {\n"
"$vol($side) umount\n"
"}\n"
"cd $gAppCWD\n"
"if {! [file exists $device]} {\n"
"error \"can't open $device (no such file or directory)\"\n"
"}\n"
"if {[file isdirectory $device]} {\n"
"set type ufs\n"
"} else {\n"
"set type hfs\n"
"}\n"
"set v [$type mount $device]\n"
"set fstype($side) $type\n"
"set locked [$v islocked]\n"
"if {$type == \"ufs\"} {\n"
"set icon \"folder\"\n"
"} else {\n"
"set size [lindex [$v size] 0]\n"
"if {$size <= [expr 1440 * 1024]} {\n"
"set icon \"floppy\"\n"
"} elseif {$locked &&  \\\n"
"$size >= [expr 100 * 1024 * 1024] &&  \\\n"
"$size <= [expr 800 * 1024 * 1024]} {\n"
"set icon \"cdrom\"\n"
"} else {\n"
"set icon \"harddisk\"\n"
"}\n"
"}\n"
"$side.info.x.icon config -bitmap sm_$icon\n"
"pack $side.info.x.icon -before $side.info.x.msg -side left -padx 0.5m\n"
"if {$locked} {\n"
"pack $side.info.x.lock -side left -padx 0.5m\n"
"} else {\n"
"pack forget $side.info.x.lock\n"
"}\n"
"pack $side.mb.pop\n"
"$side.sub.open config -text \"Close\" -command [list close_volume $side]\n"
"$side.sub.info config -state normal\n"
"set vol($side) $v\n"
"set dev($side) $device\n"
"set media($side) $icon\n"
"updatelist $side; clearlists\n"
"if {$fstype(.l) == $fstype(.r)} {\n"
"set state disabled\n"
"set gXMode auto\n"
"} else {\n"
"set state normal\n"
"}\n"
"foreach mode {auto macb binh text raw} {\n"
".m.3.mode.$mode config -state $state\n"
"}\n"
"}\n"
"proc flushtask {} {\n"
"global gFlushInterval\n"
"after $gFlushInterval flushtask\n"
"watch_cursor\n"
"hfs flushall\n"
"}\n"
"if {$argc > 0 && [string compare [lindex $argv 0] \"--\"] == 0} {\n"
"incr argc -1\n"
"set argv [lreplace $argv 0 0]\n"
"}\n"
"if {[string compare [lindex $argv 0] \"--license\"] == 0} {\n"
"puts -nonewline stdout \"\\n[hfs license]\"\n"
"exit\n"
"}\n"
"if {[string compare [lindex $argv 0] \"--version\"] == 0} {\n"
"puts stdout \"[hfs version] - [hfs copyright]\"\n"
"puts stdout \"`$argv0 --license' for licensing information.\"\n"
"exit\n"
"}\n"
"proc makelist {w click other} {\n"
"global gSmallFont\n"
"frame $w\n"
"frame $w.mb -height 30\n"
"menubutton $w.mb.pop -textvariable cwd($w)  \\\n"
"-indicatoron 1 -menu $w.mb.pop.m  \\\n"
"-relief raised -bd 2 -padx 4p -pady 4p  \\\n"
"-highlightthickness 2 -anchor c\n"
"menu $w.mb.pop.m -tearoff 0\n"
"frame $w.info -height 16\n"
"pack propagate $w.info 0\n"
"frame $w.info.x\n"
"pack $w.info.x -expand 1\n"
"label $w.info.x.icon\n"
"label $w.info.x.msg -font $gSmallFont -text \"\"\n"
"label $w.info.x.lock -bitmap padlock\n"
"pack $w.info.x.msg -side left -padx 0.5m\n"
"frame $w.mid -bd 0\n"
"listbox $w.mid.lb -xscroll \"$w.bot.sb set\" -yscroll \"$w.mid.sb set\"  \\\n"
"-exportselection 0 -height 16 -width 25 -selectmode extended\n"
"scrollbar $w.mid.sb -orient vert -command [list $w.mid.lb yview]\n"
"bind $w.mid.lb <Button-1> [list $other selection clear 0 end]\n"
"bind $w.mid.lb <KeyPress> [list $other selection clear 0 end]\n"
"bind $w.mid.lb <ButtonRelease-1> [list wclick $w $click]\n"
"bind $w.mid.lb <KeyRelease> [list wclick $w $click]\n"
"bind $w.mid.lb <Double-ButtonRelease-1> \".m.1.ops.view invoke\"\n"
"bind $w.mid.lb <Key-Return> \".m.1.ops.view invoke\"\n"
"pack $w.mid.sb -side right -fill y\n"
"pack $w.mid.lb -side right -fill both -expand 1\n"
"frame $w.bot\n"
"scrollbar $w.bot.sb -orient horiz -command [list $w.mid.lb xview]\n"
"frame $w.bot.c -height 24 -width 24\n"
"pack $w.bot.c -side right\n"
"pack $w.bot.sb -side bottom -fill x\n"
"frame $w.sub -relief sunken -bd 1\n"
"frame $w.sub.space1 -width 1m\n"
"button $w.sub.open -width 8 -text \"Open...\"  \\\n"
"-command [list open_volume $w]\n"
"button $w.sub.info -width 8 -text \"Volume Info\" -state disabled  \\\n"
"-command [list volume_info $w]\n"
"frame $w.sub.space2 -width 1m\n"
"pack $w.sub.space1 -side left\n"
"pack $w.sub.open $w.sub.info  \\\n"
"-side left -pady 1m -padx 0.5m -fill x -expand 1\n"
"pack $w.sub.space2 -side left\n"
"frame $w.space -height 2m\n"
"pack $w.space -side bottom\n"
"pack $w.mb -side top\n"
"pack $w.sub -side bottom -fill x -pady 1m -ipadx 2m\n"
"pack $w.info $w.bot -side bottom -fill x\n"
"pack $w.mid -side top -fill both -expand 1\n"
"}\n"
"proc wclick {side copytext} {\n"
"set box $side.mid.lb\n"
"set sel [$box curselection]\n"
"global gXMode gAutoModeSelect\n"
"global vol dir fstype\n"
"if {$side == \".l\"} {\n"
"set other \".r\"\n"
"} else {\n"
"set other \".l\"\n"
"}\n"
"set cstate normal\n"
"if {! [info exists vol($other)]} {\n"
"set cstate disabled\n"
"}\n"
"if {[llength $sel] == 0} {\n"
".m.1.ops.view config -state disabled -text \"View\"\n"
".m.1.ops.copy config -state disabled -text \"Copy\"\n"
".m.2.ops.info config -state disabled\n"
".m.2.ops.rena config -state disabled\n"
".m.2.ops.dele config -state disabled\n"
"} elseif {[llength $sel] == 1} {\n"
"array set item [lindex $dir($side) [lindex $sel 0]]\n"
"switch -glob $item(kind) {\n"
"directory {\n"
"set viewtext \"Open\"\n"
"set vstate normal\n"
"}\n"
"file {\n"
"set viewtext \"View\"\n"
"set mode [$fstype($side)_automode $vol($side) item]\n"
"if {$mode == \"text\" || $mode == \"binh\"} {\n"
"set vstate normal\n"
"} else {\n"
"set vstate disabled\n"
"}\n"
"}\n"
"}\n"
".m.1.ops.view config -state $vstate -text $viewtext  \\\n"
"-command [list do_open $side]\n"
".m.1.ops.copy config -state $cstate -text $copytext  \\\n"
"-command [list do_copy $side $other]\n"
".m.2.ops.info config -state normal -command [list do_info $side]\n"
".m.2.ops.rena config -state normal -command [list do_rename $side]\n"
".m.2.ops.dele config -state normal -command [list do_delete $side]\n"
"if {$gAutoModeSelect &&  \\\n"
"[.m.3.mode.auto cget -state] != \"disabled\"} {\n"
"if {[info exists mode]} {\n"
"set gXMode $mode\n"
"} else {\n"
"set gXMode [$fstype($side)_automode $vol($side) item]\n"
"}\n"
"}\n"
"} else {\n"
".m.1.ops.view config -state disabled -text \"View\"\n"
".m.1.ops.copy config -state $cstate -text $copytext  \\\n"
"-command [list do_copy $side $other]\n"
".m.2.ops.info config -state normal -command [list do_info $side]\n"
".m.2.ops.rena config -state disabled\n"
".m.2.ops.dele config -state normal -command [list do_delete $side]\n"
"if {$gAutoModeSelect &&  \\\n"
"[.m.3.mode.auto cget -state] != \"disabled\"} {\n"
"foreach ind $sel {\n"
"array set item [lindex $dir($side) $ind]\n"
"set auto [$fstype($side)_automode $vol($side) item]\n"
"if {[info exists mode]} {\n"
"if {$mode != $auto} {\n"
"set mode auto\n"
"break\n"
"}\n"
"} else {\n"
"set mode $auto\n"
"}\n"
"}\n"
"set gXMode $mode\n"
"}\n"
"}\n"
"}\n"
"frame .m\n"
"frame .m.1\n"
"frame .m.1.ops -relief sunken -bd 1\n"
"frame .m.1.ops.space1 -height 0.5m\n"
"button .m.1.ops.view -state disabled -text \"View\"\n"
"button .m.1.ops.copy -state disabled -text \"Copy\"\n"
"frame .m.1.ops.space2 -height 0.5m\n"
"pack  \\\n"
".m.1.ops.space1  \\\n"
".m.1.ops.view .m.1.ops.copy  \\\n"
".m.1.ops.space2  \\\n"
"-side top -fill x -padx 1m -pady 0.5m\n"
"pack .m.1.ops -side top -fill x\n"
"frame .m.2\n"
"frame .m.2.ops -relief sunken -bd 1\n"
"frame .m.2.ops.space1 -height 0.5m\n"
"button .m.2.ops.info -state disabled -text \"Get Info\"\n"
"button .m.2.ops.rena -state disabled -text \"Rename...\"\n"
"button .m.2.ops.dele -state disabled -text \"Delete\"\n"
"frame .m.2.ops.space2 -height 0.5m\n"
"pack  \\\n"
".m.2.ops.space1  \\\n"
".m.2.ops.info .m.2.ops.rena .m.2.ops.dele  \\\n"
".m.2.ops.space2  \\\n"
"-side top -fill x -padx 1m -pady 0.5m\n"
"pack .m.2.ops -side top -fill x\n"
"frame .m.3\n"
"label .m.3.l -text \"Mode\"\n"
"frame .m.3.mode -relief groove -bd 2\n"
"frame .m.3.mode.space1 -height 1m\n"
"radiobutton .m.3.mode.macb -font $gThinFont -text \"MacBinary II\"  \\\n"
"-var gXMode -value macb -anchor w\n"
"radiobutton .m.3.mode.binh -font $gThinFont -text \"BinHex\"  \\\n"
"-var gXMode -value binh -anchor w\n"
"radiobutton .m.3.mode.text -font $gThinFont -text \"Text\"  \\\n"
"-var gXMode -value text -anchor w\n"
"radiobutton .m.3.mode.raw -font $gThinFont -text \"Raw Data\"  \\\n"
"-var gXMode -value raw -anchor w\n"
"radiobutton .m.3.mode.auto -font $gThinFont -text \"Automatic\"  \\\n"
"-var gXMode -value auto -anchor w\n"
"frame .m.3.mode.space2 -height 1m\n"
"set gXMode auto\n"
"pack  \\\n"
".m.3.mode.space1  \\\n"
".m.3.mode.macb  \\\n"
".m.3.mode.binh  \\\n"
".m.3.mode.text  \\\n"
".m.3.mode.raw  \\\n"
".m.3.mode.auto  \\\n"
".m.3.mode.space2  \\\n"
"-side top -fill x -padx 1m\n"
"pack .m.3.l .m.3.mode -side top -fill x\n"
"pack .m.1 .m.2 .m.3 -side top -fill x -padx 2m -pady 2m\n"
"frame .mb -relief raised -bd 2\n"
"frame .mbpad -height 3m\n"
"menubutton .mb.file -text \"File\" -menu .mb.file.m\n"
"menubutton .mb.opts -text \"Options\" -menu .mb.opts.m\n"
"menubutton .mb.help -bitmap help -menu .mb.help.m\n"
"pack .mb.file .mb.opts -side left\n"
"pack .mb.help -side right -fill y -ipadx 2m\n"
"menu .mb.file.m -tearoff 0\n"
"foreach menuitem {\n"
"{command -label \"Open...\" -command {open_volume $gMountSide}}\n"
"{separator}\n"
"{command -label \"Format Disk...\" -command \"format_disk\"}\n"
"{command -label \"Eject Disk\" -command \"hfs flushall; exec eject\"}\n"
"{separator}\n"
"{command -label \"Quit\" -command \"destroy .\"}\n"
"} {eval .mb.file.m add $menuitem}\n"
"menu .mb.opts.m -tearoff 0\n"
"foreach menuitem {\n"
"{checkbutton -label \"Show All Files\" -variable gShowAllFiles  \\\n"
"-command \"watch_cursor; updatelist .l; updatelist .r; clearlists\"}\n"
"{separator}\n"
"{checkbutton -label \"Ask Before Delete\" -variable gAskDelete}\n"
"{checkbutton -label \"Auto Mode Select\" -variable gAutoModeSelect}\n"
"} {eval .mb.opts.m add $menuitem}\n"
"set gAutoModeSelect 1\n"
"set gAskDelete 1\n"
"menu .mb.help.m -tearoff 0\n"
"foreach menuitem {\n"
"{command -label \"About\" -command \"help_about\"}\n"
"{command -label \"Software License\" -command \"help_license\"}\n"
"{separator}\n"
"{command -label \"Options\" -command \"help_options\"}\n"
"{command -label \"Transfer Modes\" -command \"help_modes\"}\n"
"} {eval .mb.help.m add $menuitem}\n"
"makelist .l \">> Copy >>\" .r.mid.lb\n"
"makelist .r \"<< Copy <<\" .l.mid.lb\n"
"rename makelist \"\"\n"
"pack .mb .mbpad -side top -fill x\n"
"pack .l -side left -fill both -expand 1 -padx 3m\n"
"pack .r -side right -fill both -expand 1 -padx 3m\n"
"pack .m -side left\n"
"wm title . \"Macintosh HFS Volume Browser\"\n"
"wm iconbitmap . macdaemon\n"
"wm iconmask . macdaemon_mask\n"
"wm iconname . \"HFS Browser\"\n"
". config -cursor left_ptr\n"
"tk appname xhfs\n"
"set gAppCWD [pwd]\n"
"set fstype(.l) none\n"
"set fstype(.r) none\n"
"if {$argc > 2} {\n"
"puts stderr \"Usage: $argv0 \\[left-vol \\[right-vol]]\"\n"
"exit 1\n"
"}\n"
"if {$argc > 0} {\n"
"mountdev .l [lindex $argv 0]\n"
"if {$argc > 1} {\n"
"mountdev .r [lindex $argv 1]\n"
"}\n"
"}\n"
"if {$argc < 2} {\n"
"mountdev .r .\n"
"}\n"
"after $gFlushInterval flushtask\n"
;
